/***
 * $Source: /usr/home/ldl/langs/fm/RCS/mstr.c,v $
 * $Revision: 0.19980909 $ $Date: 1998/09/09 20:46:28 $
 */

/**
 * FM - Femto-M[UMPS].
 * M String management.
 * Eventually with GC.
 */

#include "fm.h"

static
long	memcnt = 0L;

void
freeMStr(s)						/* Function	*/
	MStr	s;
{
	if (s.data) {
/*
printf("data=0x%p %8ld size=%d freeMStr '%.*s'\n", 
s.data, memcnt++, (int)s.size, (int)s.size, (char *)s.data);
 */
		free(s.data);
	}
} /* freeMStr */

MStr
str2MStr(str)						/* Function	*/
	char   *str;
{
	MStr    s;
	if (strlen(str) == 0) {		/* Don't dup empty strings	*/
		s.size = 0;
		s.data = NULL;
	} else {
		s.size = strlen(str);
		s.data = strdup(str);
/*
printf("data=0x%p %8ld size=%d str2MStr '%.*s'\n", 
s.data, memcnt++, (int)s.size, (int)s.size, (char *)s.data);
 */
	}
	return s;
} /* str2MStr */

/* End of $Source: /usr/home/ldl/langs/fm/RCS/mstr.c,v $ */
